<template>
  <div class="py-8 px-4 lg:py-16 lg:px-12">
    <UBreadcrumb :links="links" />
    <div class="flex flex-col md:flex-row items-center justify-between space-y-3 md:space-y-0 md:space-x-4 p-4">
      <div class="w-full md:w-1/2">
        <form class="flex items-center">
          <label for="simple-search" class="sr-only">Search</label>
          <div class="relative w-full">
            <div class="absolute inset-y-0 left-0 flex items-center pl-3 pointer-events-none">
              <svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400" fill="currentColor" viewbox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                <path fill-rule="evenodd" d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z" clip-rule="evenodd" />
              </svg>
            </div>
            <UInput v-model="q" placeholder="Chercher un utilisateur..." />
          </div>
        </form>
      </div>
      <div class="w-full md:w-auto flex flex-col md:flex-row space-y-2 md:space-y-0 items-stretch md:items-center justify-end md:space-x-3 flex-shrink-0">
        <NuxtLink to="/users/new" class="flex items-center justify-center text-white bg-primary-700 hover:bg-primary-800 focus:ring-4 focus:ring-primary-300 font-medium rounded-lg text-sm px-4 py-2 dark:bg-primary-600 dark:hover:bg-primary-700 focus:outline-none dark:focus:ring-primary-800">
          <UIcon name="i-heroicons-plus-16-solid" class="text-2xl mr-4" />
          Ajouter un utilisateur
        </NuxtLink>
      </div>
    </div>
    <UTable :rows="filteredRows" :columns="columns" :loading="loading">
      <template #createdAt-data="{ row }">
        {{ moment(row.createdAt).format('DD/MM/YYYY') }}
      </template>
      <template #isAdmin-data="{ row }">
        {{ row.isAdmin ? 'Oui' : 'Non' }}
      </template>
      <template #actions-data="{ row }">
        <UButton type="button" @clik="isModal = true" class="py-2 px-3 text-sm font-medium text-center text-white bg-red-600 rounded-lg hover:bg-red-700 focus:ring-4 focus:outline-none focus:ring-red-300 dark:bg-red-500 dark:hover:bg-red-600 dark:focus:ring-red-900">
          <UIcon name="i-heroicons-trash" />
        </UButton>
      </template>
    </UTable>
    <div class="flex justify-end px-3 py-3.5 border-t border-gray-200 dark:border-gray-700">
      <UPagination v-model="page" :page-count="pageCount" :total="data.length" />
    </div>
    <div id="deleteModal" tabindex="-1" aria-hidden="true" :class="isModal ? '' : 'hidden'" class="overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 justify-center items-center w-full md:inset-0 h-modal md:h-full">
      <div class="relative p-4 w-full max-w-md h-full md:h-auto">
        <!-- Modal content -->
        <div class="relative p-4 text-center bg-white rounded-lg shadow dark:bg-gray-800 sm:p-5">
          <button type="button" @click="isModal = false" class="text-gray-400 absolute top-2.5 right-2.5 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-gray-600 dark:hover:text-white" data-modal-toggle="deleteModal">
            <svg aria-hidden="true" class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path></svg>
            <span class="sr-only">Close modal</span>
          </button>
          <svg class="text-gray-400 dark:text-gray-500 w-11 h-11 mb-3.5 mx-auto" aria-hidden="true" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M9 2a1 1 0 00-.894.553L7.382 4H4a1 1 0 000 2v10a2 2 0 002 2h8a2 2 0 002-2V6a1 1 0 100-2h-3.382l-.724-1.447A1 1 0 0011 2H9zM7 8a1 1 0 012 0v6a1 1 0 11-2 0V8zm5-1a1 1 0 00-1 1v6a1 1 0 102 0V8a1 1 0 00-1-1z" clip-rule="evenodd"></path></svg>
          <p class="mb-4 text-gray-500 dark:text-gray-300">Are you sure you want to delete this item?</p>
          <div class="flex justify-center items-center space-x-4">
            <button data-modal-toggle="deleteModal" @click="isModal = false" type="button" class="py-2 px-3 text-sm font-medium text-gray-500 bg-white rounded-lg border border-gray-200 hover:bg-gray-100 focus:ring-4 focus:outline-none focus:ring-primary-300 hover:text-gray-900 focus:z-10 dark:bg-gray-700 dark:text-gray-300 dark:border-gray-500 dark:hover:text-white dark:hover:bg-gray-600 dark:focus:ring-gray-600">
              No, cancel
            </button>
            <button type="submit" class="py-2 px-3 text-sm font-medium text-center text-white bg-red-600 rounded-lg hover:bg-red-700 focus:ring-4 focus:outline-none focus:ring-red-300 dark:bg-red-500 dark:hover:bg-red-600 dark:focus:ring-red-900">
              Yes, I'm sure
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { useNuxtApp } from '#app'
import type { Api } from '~/types/api'
import moment from "moment";

const data = ref({})
const loading = ref(true)
const error = ref(null)
const page = ref(1)
const pageCount = 5
const router = useRouter()
const isModal = ref(false)

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api

const columns = [
  {
    key: 'username',
    label: 'Nom'
  },
  {
    key: 'email',
    label: 'Email '
  },
  {
    key: 'createdAt',
    label: 'Créé le'
  },
  {
    key: 'isAdmin',
    label: 'Admin ?'
  },
  {
    key: 'actions',
    label: 'Actions'
  }]

async function loadData() {
  try {
    const response = await $api.getUsers()
    data.value = response
    console.log(response)
  } catch (err) {
    error.value = err.message
    console.error('Error fetching data:', err)
  } finally {
    loading.value = false
  }
}

const q = ref('')

const filteredRows = computed(() => {
  if (!q.value) {
    return data.value
  }

  return data.filter((item) => {
    return Object.values(item).some((value) => {
      return String(value).toLowerCase().includes(q.value.toLowerCase())
    })
  })
})

const links = [{
  label: 'Home',
  icon: 'i-heroicons-home',
  to: '/feed'
}, {
  label: 'Utilisateurs',
  icon: 'i-heroicons-square-3-stack-3d'
}]

onMounted(() => {
  loadData()
})
</script>